%zeropage basicsafe
%import diskio
%import textio
%import pcmkit

main {

    sub start() {

        txt.print("pcm virtual channels demo\n")
        txt.print("press 1-4 to trigger sounds\n\n")

        txt.print("            playing - bank - slot")

        pcmkit.LoadSample("test.raw",       0, 1, $a000)
        pcmkit.LoadSample("bullet.raw",     1, 2, $a000)
        pcmkit.LoadSample("bird.raw",       2, 3, $a000)
        pcmkit.LoadSample("fireball.raw",   3, 4, $a000)
    
        setup_irq_audio()

        ubyte key
        repeat{
            sys.waitvsync()
            key = cbm.GETIN()
            ; txt.print_ub(key)

            if key == 49 pcmkit.Play(0)
            if key == 50 pcmkit.Play(1)
            if key == 51 pcmkit.Play(2)
            if key == 52 pcmkit.Play(3)

            update_status()
        }

    }

    sub update_status() {
        txt.home()
        txt.row(4)

        channel_status(0)
        channel_status(1)
        channel_status(2)
        channel_status(3)
   }

    sub channel_status(ubyte channel)
    {
        txt.print("vchannel ")
        txt.print_ub(channel)
        txt.print(" :   ")
        txt.print_ub(pcmkit.aud_channel_playing[channel] as ubyte)
        txt.print("    -   ")
        txt.print_ub(pcmkit.aud_channel_bank[channel] as ubyte)
        txt.print("  -   ")
        txt.print_ub(pcmkit.aud_channel_slot[channel] as ubyte)
        txt.nl()
    }

    sub setup_irq_audio() {
        sys.set_irqd()
        cx16.enable_irq_handlers(false)
        cx16.set_aflow_irq_handler(pcm_irq)
        pcmkit.Init()
        sys.clear_irqd()
    }

    sub  pcm_irq() -> bool {

        pcmkit.update()
        return false
    }

}