%import diskio
%import textio

pcmkit {
    ubyte[4] aud_channel_bank = 0
    uword[4] aud_channel_offset = 0
    uword[4] aud_channel_length = 0
    bool[4]  aud_channel_playing = false
    ubyte[4] aud_channel_slot = 0
  
    ubyte[16] aud_bank
    uword[16] aud_offset
    uword[16] aud_length

    sub Init() {
        cx16.VERA_AUDIO_DATA = 0
        cx16.VERA_AUDIO_CTRL = $0f
        cx16.VERA_AUDIO_RATE = 128
    }

    sub LoadSample(str file, ubyte slot, ubyte bank, uword startaddress) {

        cx16.rambank(bank)

        aud_bank[slot] = bank
        aud_offset[slot] = startaddress
        aud_length[slot] = diskio.load_raw(file, startaddress) - startaddress
    
        ; txt.print(file)
        ; txt.spc()
        ; txt.print_uwhex(aud_length[bank], true)
        ; txt.nl()
    }  

      sub Play(ubyte slot) {

        if check_channel(0,slot) == true return
        if check_channel(1,slot) == true return
        if check_channel(2,slot) == true return
        if check_channel(3,slot) == true return

        ;No more channels available
        ;priority system needed?

        ; txt.print("no more channels available\n")
    }

    sub check_channel(ubyte channel, ubyte slot) -> bool{

        if aud_channel_playing[channel] == false {
            aud_channel_bank[channel] = aud_bank[slot]
            aud_channel_offset[channel] = aud_offset[slot]
            aud_channel_length[channel] = aud_length[slot]
            aud_channel_playing[channel] = true
            aud_channel_slot[channel] = slot
            return true
        }       
        return false
    }
    sub update_sample(ubyte channel) {
        if aud_channel_playing[channel] == true {
        
            cx16.rambank(aud_channel_bank[channel])
            cx16.VERA_AUDIO_DATA = @(aud_channel_offset[channel])

            aud_channel_offset[channel]++
            aud_channel_length[channel]--

            if aud_channel_length[channel] == 0 {
                aud_channel_playing[channel] = false
                ; txt.print_ub(channel)
                ; txt.print("-\n")
            }
        }
        else cx16.VERA_AUDIO_DATA = 0
    }

    sub update()
    {
        repeat 255 {
            pcmkit.update_sample(0)
            pcmkit.update_sample(1)
            pcmkit.update_sample(2)
            pcmkit.update_sample(3)
        }        
    }

}